﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.9
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Dim nativeMe, lc As JavaObject
End Sub

'Initializes the piechart object
Public Sub Initialize
	
	nativeMe = Me

End Sub

'Draw the pioe chart
public Sub drawPieChart() As JavaObject
	
	lc = nativeMe.RunMethod("DrawChart", Null)
	Return lc
	
End Sub

'Set the labels of the pie chart slices
public Sub setPieLabels (xvals() As String)
	
	nativeMe.RunMethod("setPieLabels", Array(xvals))
	
End Sub

'Set the values of the pie chart slices
'Convert the values to % prior to passing it to this sub - if you want to show each slice as a percentage of the total value
public Sub setPieValues (yvals_1() As Float)
	
	nativeMe.RunMethod("setPieValues", Array(yvals_1))
	
End Sub

'Set the title of the pie chart
public Sub setTitle(title As String)
	
	nativeMe.RunMethod("setTitle", Array(title))
	
End Sub

Public Sub callback (txt As String)
	Log ("from event: " & txt)
End Sub



#if Java

import javafx.application.Application;

import javafx.scene.Scene;
import javafx.stage.Stage;
import javafx.scene.chart.*;
import javafx.geometry.Side;
import javafx.scene.control.Label;
import javafx.event.EventHandler;
import javafx.scene.input.MouseEvent;
import javafx.scene.control.Label;
import javafx.scene.paint.Color;
import javafx.scene.text.Text;

private static BA ba;

	public PieChart DrawChart() {
				
        final PieChart piechart = new PieChart();

		for (int i = 0; i < xvals.length; i++) {
		
	        PieChart.Data slice1 = new PieChart.Data(xvals[i], yvals_1[i]);
	        piechart.getData().add(slice1);
		
		}
		
        piechart.setTitle(title);
		piechart.setLabelLineLength(8);
//		piechart.setLegendSide(Side.LEFT);
		piechart.setClockwise(true);
		piechart.setLabelsVisible(true);
		piechart.setLegendVisible(true);
		piechart.setStartAngle(90);
		
//		final Label caption = new Label("");
//		caption.setTextFill(Color.DARKORANGE);
//		caption.setStyle("-fx-font: 24 arial;");
		
		for (final PieChart.Data data : piechart.getData()) {
		    data.getNode().addEventHandler(MouseEvent.MOUSE_PRESSED,
		        new EventHandler<MouseEvent>() {
		            @Override public void handle(MouseEvent e) {
						//caption.setTranslateX(e.getSceneX());
                		//caption.setTranslateY(e.getSceneY());	
						//caption.setText(String.valueOf(data.getPieValue()) + "%");				
						//BA.Log("" + String.valueOf(data.getPieValue()) + "%");
						ba.raiseEventFromUI(this, "callback", String.valueOf(data.getPieValue()) + "%");
		             }
		        });
		}

		return piechart;
	}

	private static String[] xvals;
	public void setPieLabels(String[] xvals) {
		this.xvals = xvals;
	}

	private static String title = "";
	public void setTitle(String title) {
		this.title = title;
	}



	private static float[] yvals_1;

	public void setPieValues(float[] yvals_1) {
		this.yvals_1 = yvals_1;
	}


#End If
